
/* eslint-disable */
const { contextBridge, ipcRenderer, webFrame } = require('electron');
const methodsList = JSON.parse('[{"method":"backup","submethod":"list","name":"backup.list","type":"promise"},{"method":"backup","submethod":"create","name":"backup.create","type":"promise"},{"method":"backup","submethod":"delete","name":"backup.delete","type":"promise"},{"method":"backup","submethod":"onBackupProgress","name":"backup.onBackupProgress","type":"callback"},{"method":"settings","submethod":"get","name":"settings.get","type":"promise"},{"method":"settings","submethod":"setProperty","name":"settings.setProperty","type":"promise"},{"method":"tables","submethod":"get","name":"tables.get","type":"promise"},{"method":"tables","submethod":"delete","name":"tables.delete","type":"promise"},{"method":"tables","submethod":"create","name":"tables.create","type":"promise"},{"method":"proxies","submethod":"add","name":"proxies.add","type":"promise"},{"method":"proxies","submethod":"addInput","name":"proxies.addInput","type":"promise"},{"method":"proxies","submethod":"check","name":"proxies.check","type":"promise"},{"method":"proxies","submethod":"get","name":"proxies.get","type":"promise"},{"method":"proxies","submethod":"delete","name":"proxies.delete","type":"promise"},{"method":"proxies","submethod":"onProxyUpdate","name":"proxies.onProxyUpdate","type":"callback"},{"method":"pipeline","submethod":"create","name":"pipeline.create","type":"promise"},{"method":"pipeline","submethod":"add","name":"pipeline.add","type":"promise"},{"method":"pipeline","submethod":"start","name":"pipeline.start","type":"promise"},{"method":"pipeline","submethod":"stop","name":"pipeline.stop","type":"promise"},{"method":"pipeline","submethod":"cancel","name":"pipeline.cancel","type":"promise"},{"method":"pipeline","submethod":"onCheckUpdate","name":"pipeline.onCheckUpdate","type":"callback"},{"method":"pipeline","submethod":"onStatsUpdate","name":"pipeline.onStatsUpdate","type":"callback"},{"method":"pipeline","submethod":"onFinish","name":"pipeline.onFinish","type":"callback"},{"method":"vk","submethod":"getItems","name":"vk.getItems","type":"promise"},{"method":"vk","submethod":"deleteItems","name":"vk.deleteItems","type":"promise"},{"method":"vk","submethod":"setField","name":"vk.setField","type":"promise"},{"method":"vk","submethod":"getFriends","name":"vk.getFriends","type":"promise"},{"method":"vk","submethod":"getGroups","name":"vk.getGroups","type":"promise"},{"method":"vk","submethod":"getGroupsAdmin","name":"vk.getGroupsAdmin","type":"promise"},{"method":"tg","submethod":"openTdata","name":"tg.openTdata","type":"promise"},{"method":"items","submethod":"refreshProxy","name":"items.refreshProxy","type":"promise"},{"method":"captcha","submethod":"loadVKCaptcha","name":"captcha.loadVKCaptcha","type":"promise"},{"method":"captcha","submethod":"captchaInfo","name":"captcha.captchaInfo","type":"promise"},{"method":"captcha","submethod":"onCaptchaInfo","name":"captcha.onCaptchaInfo","type":"callback"},{"method":"captcha","submethod":"solveCaptcha","name":"captcha.solveCaptcha","type":"promise"},{"method":"logger","submethod":"onLog","name":"logger.onLog","type":"callback"},{"method":"logger","submethod":"onError","name":"logger.onError","type":"callback"},{"method":"browser","submethod":"openWithItem","name":"browser.openWithItem","type":"promise"},{"method":"browser","submethod":"open","name":"browser.open","type":"promise"},{"method":"vklogin","submethod":"openWithItem","name":"vklogin.openWithItem","type":"promise"},{"method":"vklogin","submethod":"open","name":"vklogin.open","type":"promise"},{"method":"vklogin","submethod":"openWithRandomProxy","name":"vklogin.openWithRandomProxy","type":"promise"},{"method":"misc","submethod":"nativeButton","name":"misc.nativeButton","type":"send"},{"method":"misc","submethod":"openBrowser","name":"misc.openBrowser","type":"promise"},{"method":"misc","submethod":"clipboard","name":"misc.clipboard","type":"promise"},{"method":"misc","submethod":"GPUFeatures","name":"misc.GPUFeatures","type":"promise"},{"method":"misc","submethod":"onGeneralInfo","name":"misc.onGeneralInfo","type":"promise"},{"method":"misc","submethod":"onReady","name":"misc.onReady","type":"callback"},{"method":"misc","submethod":"onMaximize","name":"misc.onMaximize","type":"callback"},{"method":"misc","submethod":"onUnmaximize","name":"misc.onUnmaximize","type":"callback"}]')
let requestCounter = 0
let methods = {};
for (let method of methodsList) {
  if (!methods[method.method]) {
    methods[method.method] = {}
  }
  if (method.type == "send") {
    methods[method.method][method.submethod] = (requestMsg = {}) => {
      ipcRenderer.send('req-'+method.name, JSON.stringify(requestMsg));
    };
  }
  if (method.type == "promise") {
    methods[method.method][method.submethod] = (requestMsg = {}) => {
      requestMsg.requestId = requestCounter
      requestCounter++
      return new Promise((resolve) => {
        ipcRenderer.send('req-'+method.name, JSON.stringify(requestMsg));
        ipcRenderer.once(
          'res-'+method.name+'-id'+requestMsg.requestId,
          (event, msg) => resolve(JSON.parse(msg))
        );
      });
    };
  }
  if (method.type == "callback") {
    methods[method.method][method.submethod] = (cb) =>
      ipcRenderer.on(method.name, (e, msg) => {
        cb(JSON.parse(msg));
      });
  }
}

contextBridge.exposeInMainWorld("bridge", {
  ...methods,
  isElectron: true
})
